% bwlabel.m

function [L]=bwlabel(BW,connectivity)

rows=size(BW,1);
cols=size(BW,2);
newlable=1;
L1 = zeros(rows,cols);
same=[];

for i=1:cols
    for j=1:rows
        single=BW(j,i);
        
        if single==1
            if j-1 < 1
                r=0;
            else
                r=L1(j-1,i);
            end
            
            if j-1 < 1 || i-1 < 1
                s=0;
            else
                s=L1(j-1,i-1);
            end
               
            if i-1 < 1
                t=0;
            else
                t=L1(j,i-1);
            end
            
            if i-1 < 1 || j+1 > rows
                u=0;
            else
                u=L1(j+1,i-1);
            end
            
            if r==0 && s==0 && t==0 && u==0
                %assign new value
                L1(j,i)=newlable;
                newlable=newlable+1;
            else
                %assign neighbor's value
                if r ~=0
                    L1(j,i)=r;
                elseif s ~=0
                    L1(j,i)=s;
                elseif t ~=0
                    L1(j,i)=t;
                else
                    L1(j,i)=u;
                end
                %remember same labels
                
                if r ~=0 && r~=L1(j,i)
                    same=[same [r L1(j,i)]'];
                end
                
                if s ~=0 && s~=L1(j,i)
                    same=[same [s L1(j,i)]'];
                end
                
                if t ~=0 && t~=L1(j,i)
                    same=[same [t L1(j,i)]'];
                end
                
                if u ~=0 && u~=L1(j,i)
                    same=[same [u L1(j,i)]'];                    
                end
            end
        end
    end
end

%merge same labels
for s=1:size(same,2)
    orig=same(1,s);
    target=same(2,s);
    
    for i=1:cols
        for j=1:rows
            single=L1(j,i);
        
            if single==orig
                L1(j,i)=target;
            end    
        end
    end
end    

L=L1;
    

